/* $Id: d_mos_base.h,v 18.14 2000/08/31 21:51:22 al Exp $ -*- C++ -*-
 * MOS model - base for levels 1,2,3,6
 */ 
/* This file is automatically generated. DO NOT EDIT */
#ifndef D_MOS_BASE_H_INCLUDED
#define D_MOS_BASE_H_INCLUDED

#include "d_mos.h"
/*--------------------------------------------------------------------------*/
class SDP_MOS_BASE
  :public SDP_MMB{
public:
  explicit SDP_MOS_BASE(const COMPONENT_COMMON*);
public:
  double le;	// -23-c- actual (electrical) channel length
  double we;	// --3-c- actual (electrical) channel width
  double ad;	// ----c- drain area, actual
  double as;	// ----c- source area, actual
  double cgate;	// -----b gate to channel capacitance
  double idsat;	// -----b drain junction saturation current
  double issat;	// -----b source junction saturation current
  double rd;	// -----b ohmic drain resistance
  double rs;	// -----b ohmic source resistance
  double phi;	// surface potential at strong inversion
};
/*--------------------------------------------------------------------------*/
class TDP_MOS_BASE{
public:
  explicit TDP_MOS_BASE(const DEV_MOS*);
public:
};
/*--------------------------------------------------------------------------*/
class MODEL_MOS_BASE
  :public MODEL_MMB{
public:
  // using generated copy constructor, should be unreachable
  explicit MODEL_MOS_BASE();
  ~MODEL_MOS_BASE() {--_count;}
public: // override virtual
  bool          parse_front(CS&);
  void          parse_params(CS&);
  void          post_parse();
  SDP_CARD* new_sdp(const COMPONENT_COMMON* c)const {return new SDP_MOS_BASE(c);}
  void          print_front(OMSTREAM&)const;
  void          print_params(OMSTREAM&)const;
  void          print_calculated(OMSTREAM&)const;
  void          tr_eval(COMPONENT*)const;
public: // not virtual
  static int    count() {return _count;}
public: // strictly internal
  static int _count;
public: // input parameters

  int level;	// dummy
  double is;	// bulk jct sat current
  double js;	// bulk jct sat current per sq meter
  double rsh;	// D & S diffusion sheet resistance
  double rd;	// drain ohmic resistance
  double rs;	// source ohmic resistance
  double cbd;	// 0-bias BD jct capacitance
  double cbs;	// 0-bias BS jct capacitance
  double cgso;	// GS overlap capacitance
  double cgdo;	// GD overlap capacitance
  double cgbo;	// GB overlap capacitance
  int cmodel;	// which capacitor model to use (2 or 3)
public: // calculated parameters
  double egap;	// energy gap at tnom
  bool needs_isub;	// 
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
